#!/usr/bin/env perl
use strict;
use warnings;


my $f=@ARGV;             # file to be scanned
my $f1;
my $f2;

my $ret=0;
my $innode=0;

###### building the file names
if ($#ARGV == 0) 
  {
$f1 = $ARGV[0].".lus";
$f2 = $ARGV[0].".wcexpr";

#open file.lus and file.wcexpr and read each line
# Hypothesis : only ONE expression in .wcexpr file, on only ONE line.
# TODO : seulement la 1e ligne (=expr) est prise en compte; generer un fichier _inv par expression
open(F1,"<".$f1) or die $!;

# creating the generated file
open(FW,">".$ARGV[0]."_inv.lus") or die $!;
# adds init definition
my $init = "node init(ck : bool) returns (o : bool); let o = true -> pre(o and not ck); tel\n";
print FW $init;

while (<F1>) {
  #ignore empty lines
  chomp;
  # if line contains the nodename
  if (/.*(\ |\t)$ARGV[0]($|\ .*|\t.*)/) {$innode = 1;}
  if (/returns/ && $innode)
    {
      my @line = split /returns/, $_;
      # if ins are on the same line
      if (exists($line[0]))
	{
	  print FW $line[0];
	};
      print FW " returns ";
      # if outs are on the same line, adds paspossib as first out
      if (exists($line[1]))
	{
	  my @out = split /\(/, $line[1];
	  my $outexpr =  "(paspossib: bool; ".$out[1]."\n";
	  print FW $outexpr;
	}
      else
	{
	  print FW "\n";
	  $ret = 1;
	}
    }
  else
    {
      # if previous line was returns, adds paspossib as first out
      if ($ret)
	{
	  my @out = split /\(/, $_;
	  my $outexpr =  "  (paspossib: bool; \n  ".$out[1]."\n";
	  print FW $outexpr;
	  $ret = 0;
	}
      else
	{
	  # adds paspossib equation before tel (expr defined in F2)
	  if (/tel/)
	    {
	      open(F2,$f2) or die $!;
	      my $inv = "  paspossib = not(".<F2>.");\n";
	      print FW $inv;
	      $innode = 0;
	      close(F2);
	    }
	  # copy of other lines
	  print FW $_;
	  print FW "\n";
	}
    }
}
close(F1);
close(FW);
}
else
  {
    printf("Usage : ecinv.pl <nodename> \n");
    printf("Files <nodename.lus> <nodename.wcexpr> required \n");
  }
